VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "comctl32.ocx"
Begin VB.Form frmMMSync 
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Sync4j Outlook Client"
   ClientHeight    =   4608
   ClientLeft      =   120
   ClientTop       =   804
   ClientWidth     =   3516
   FillColor       =   &H8000000B&
   FillStyle       =   0  'Solid
   ForeColor       =   &H80000005&
   Icon            =   "frmMMSync.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4608
   ScaleWidth      =   3516
   StartUpPosition =   3  'Windows Default
   Visible         =   0   'False
   Begin ComctlLib.StatusBar StatusBar1 
      Align           =   2  'Align Bottom
      Height          =   372
      Left            =   0
      TabIndex        =   1
      Top             =   4236
      Width           =   3516
      _ExtentX        =   6202
      _ExtentY        =   656
      Style           =   1
      SimpleText      =   ""
      _Version        =   327682
      BeginProperty Panels {0713E89E-850A-101B-AFC0-4210102A8DA7} 
         NumPanels       =   1
         BeginProperty Panel1 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            Key             =   ""
            Object.Tag             =   ""
         EndProperty
      EndProperty
   End
   Begin VB.CommandButton exitButton 
      BackColor       =   &H00FFFFFF&
      Caption         =   "Synchronize"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.6
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   372
      Left            =   840
      TabIndex        =   0
      Top             =   3480
      Width           =   1692
   End
   Begin VB.Image Image4 
      BorderStyle     =   1  'Fixed Single
      Height          =   4452
      Left            =   0
      Top             =   0
      Width           =   4092
   End
   Begin VB.Image logoSync 
      Appearance      =   0  'Flat
      Height          =   924
      Left            =   1200
      Picture         =   "frmMMSync.frx":058A
      Top             =   1700
      Width           =   1104
   End
   Begin VB.Image logoSync4j 
      Height          =   888
      Left            =   620
      Picture         =   "frmMMSync.frx":58D0
      Top             =   360
      Width           =   2280
   End
   Begin VB.Menu fileControl 
      Caption         =   "File"
      Index           =   1
      NegotiatePosition=   1  'Left
      Begin VB.Menu syncControl 
         Caption         =   "Synchronize"
         Index           =   1
      End
      Begin VB.Menu exitControl 
         Caption         =   "Exit"
         Index           =   1
      End
   End
   Begin VB.Menu editControl 
      Caption         =   "Edit"
      Index           =   2
      Begin VB.Menu syncSettingsControl 
         Caption         =   "Communication Settings..."
         Index           =   1
      End
      Begin VB.Menu syncSourcesControl 
         Caption         =   "Synchronization Settings..."
         Index           =   1
      End
      Begin VB.Menu syncSchedulerSettings 
         Caption         =   "Scheduler Settings..."
         Index           =   1
      End
   End
   Begin VB.Menu helpControl 
      Caption         =   "Help"
      Index           =   1
      Begin VB.Menu logControl 
         Caption         =   "View log..."
      End
      Begin VB.Menu aboutControl 
         Caption         =   "About"
      End
   End
End
Attribute VB_Name = "frmMMSync"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
'Copyright (C) 2003-2005 Funambol
'
'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
'****************************************************************
'*Form:    frmMMSync.frm                                        *
'*Author:  Marco Magistrali - Funambol                          *
'****************************************************************


Option Explicit
Dim keyValue As Long
Public isBlocking As Boolean

Private Sub Form_Initialize()
mdMMVariables.InitCommonControls
End Sub

Private Sub aboutControl_Click()
frmMMAbout.Show 1
End Sub

Private Sub exitButton_Click()
synchronize
End Sub

Private Sub exitControl_Click(Index As Integer)
mdUnload.closeProgram

End Sub


Public Sub Form_Load()
    'During the Form Load it reads all the informations stored in the files
    'regarding the selected Folders and Item Properties to sync,
    'and store them in appropriate arrays.

On Error GoTo Form_Load_Err

Dim path As String
path = mdMMVariables.AppPath()
ChDir (path)
ChDrive (mdMMVariables.AppDrive)
mdMMShiftBit.Init


'Initialization

StatusBar1.SimpleText = ""
logoSync.Picture = LoadPicture(App.path & "\" & DIR_IMAGES & "\" & mdMMVariables.ARROWS_BMP)
logoSync4j.Picture = LoadPicture(App.path & "\" & DIR_IMAGES & "\" & mdMMVariables.LOGO_BMP)

'
' We now center window controls
'
logoSync.Left = (frmMMSync.Width - logoSync.Width) / 2
logoSync4j.Left = (frmMMSync.Width - logoSync4j.Width) / 2
exitButton.Left = (frmMMSync.Width - exitButton.Width) / 2
exitButton.Caption = mdMMVariables.EXIT_BUTTON

ReDim mdVariables.itemProperties(257)

'read from item_for_properties.db all the item properties available for user
mdLoad.loadListForProperties

'Center the form in the screen
Me.Move (Screen.Width - Me.Width) / 2, (Screen.Height - Me.Height) / 2

Form_Load_Exit:
    Exit Sub

Form_Load_Err:

    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo Form_Load_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select

End Sub

Function outlookSession() As Outlook.nameSpace
    'create a reference and logon to the default MAPI session


Dim objNamespace As Outlook.nameSpace

On Error GoTo outlookSession_Err

Set mdMMVariables.objOutlook = CreateObject("Outlook.Application")
Set objNamespace = objOutlook.GetNamespace("MAPI")

' Log on, creating a new MAPI session, using the profile and password
Call objNamespace.Logon(, , True)
Set outlookSession = objNamespace
 
outlookSession_Exit:
    Exit Function

outlookSession_Err:
    printLog "Error creating Outlook reference.", ERROR_LEVEL
    mdUnload.closeProgram
    GoTo outlookSession_Exit
    
End Function
Private Sub loadOutlook()

printDebugMessage "Enter loadOutlook method"
Set mdVariables.nameSpace = Outlook.Application.GetNamespace("MAPI")


'Dim objMySession As MAPI.Session
'Dim MyTimeZone As Long
'Set objMySession = CreateObject("MAPI.Session")
'Set objMySession = New MAPI.Session
'objMySession.Logon , , False, False
'MyTimeZone = objMySession.GetOption("TimeZone")
'objMySession.Logoff
'Set objMySession = Nothing


'read the existent folders and subfolders of the 4 types (Calendar, Contacts, Mail, Tasks)
'for the selected profile and save their EntryID and Name in the arrays of relative type

printDebugMessage "Redim calendar, contacts, tasks, notes Properties array"
'prepare the 4 arrays for the list of Item Properties to sync
'if they remain with 1 position, it means that no properties are selected
ReDim mdVariables.calendarProperties(0)
ReDim mdVariables.contactsProperties(0)
ReDim mdVariables.mailProperties(0)
ReDim mdVariables.tasksProperties(0)
ReDim mdVariables.notesProperties(0)

'test if the file with the selected item properties exists

If mdFileSystem.doesFileExist(mdVariables.NAME_PROPERTIES_FILE) Then
    printDebugMessage mdVariables.NAME_PROPERTIES_FILE + " does exists. Read readPreferencesFromFile"
    logToDebug "Item Properties Preferences YES"
    mdVariables.propExists = True
    mdFileSystem.readPreferencesFromFile mdVariables.NAME_PROPERTIES_FILE
Else
    printDebugMessage mdVariables.NAME_PROPERTIES_FILE + " does NOT exists. Read loadDefaultProperties"
    mdVariables.propExists = False
    logToDebug "File " & mdVariables.NAME_PROPERTIES_FILE & " doesn't exist." & Chr(13) & _
    "The default preferences for item properties will be loaded."
    mdFileSystem.loadDefaultProperties
End If

printDebugMessage "Exit loadOutlook method"
End Sub

Public Sub loadFoldersProperties()
printDebugMessage "Enter loadFoldersProperties method"
mdVariables.deletedFolders() = mdVariables.dummyInitializingStringArray()
mdVariables.createdListMM() = mdVariables.dummyInitializingVariantArray()
mdVariables.modifiedListMM() = mdVariables.dummyInitializingVariantArray()
mdVariables.deletedListMM() = mdVariables.dummyInitializingVariantArray()

'test if the file with the selected folders exists
If mdFileSystem.doesFileExist(mdVariables.NAME_PREFERENCES_FILE) Then
    printDebugMessage mdVariables.NAME_PREFERENCES_FILE + " does exists. Read readPreferencesFromFile"
    logToDebug "Folders Preferences YES"
    mdVariables.prefExists = True
    mdFileSystem.readPreferencesFromFile mdVariables.NAME_PREFERENCES_FILE
Else
    printDebugMessage mdVariables.NAME_PREFERENCES_FILE + " does exists. Read loadDefaultFolders"
    mdVariables.prefExists = False
    logToDebug "File " & mdVariables.NAME_PREFERENCES_FILE & " doesn't exist. Prepare Slow Sync"
    mdFileSystem.loadDefaultFolders
End If
printDebugMessage "Exit loadFoldersProperties method"
End Sub

Public Sub checkForcedSlowSync()
    
printDebugMessage "Enter checkForcedSlowSync method"

Dim i As Integer

mdLoad.readAllFolders

On Error GoTo checkSlowSync_Err
    
    If frmMMAdvancedSettings.syncCalendarMode = 1 Then
        
        For i = 1 To UBound(mdVariables.calendarFolders)
        
            'if no, delete the old selected folder if exists
            If Dir(mdVariables.calendarFolders(i).EntryID, vbDirectory) <> "" Then
                ChDir mdVariables.calendarFolders(i).EntryID
                Kill "*.*"
                ChDir ".."
                RmDir mdVariables.calendarFolders(i).EntryID 'delete the relative folder if exsists
            End If
        Next i
        mdMMVariables.deleteDirectory DIR_ALL_ITEM_CALENDARS
        mdMMVariables.deleteDirectory DIR_NEW_ITEM_CALENDARS
        mdMMVariables.deleteDirectory DIR_MOD_ITEM_CALENDARS
    End If

    If frmMMAdvancedSettings.syncContactMode = 1 Then
       For i = 1 To UBound(mdVariables.contactsFolders)
            
            If Dir(mdVariables.contactsFolders(i).EntryID, vbDirectory) <> "" Then
                ChDir mdVariables.contactsFolders(i).EntryID
                Kill "*.*"
                ChDir ".."
                RmDir mdVariables.contactsFolders(i).EntryID 'delete the relative folder if exsists
            End If
            
        Next i
        If mdFileSystem.doesFileExist(mdVariables.NAME_PREFERENCES_FILE) Then
            Kill mdVariables.NAME_PREFERENCES_FILE
        End If
        mdMMVariables.deleteDirectory DIR_ALL_ITEM_CONTACTS
        mdMMVariables.deleteDirectory DIR_NEW_ITEM_CONTACTS
        mdMMVariables.deleteDirectory DIR_MOD_ITEM_CONTACTS
    End If
    
    If frmMMAdvancedSettings.syncTaskMode = 1 Then
        
        For i = 1 To UBound(mdVariables.tasksFolders)
        
            If Dir(mdVariables.tasksFolders(i).EntryID, vbDirectory) <> "" Then
                ChDir mdVariables.tasksFolders(i).EntryID
                Kill "*.*"
                ChDir ".."
                RmDir mdVariables.tasksFolders(i).EntryID 'delete the relative folder if exsists
            End If
        
        Next i
        mdMMVariables.deleteDirectory DIR_ALL_ITEM_TASKS
        mdMMVariables.deleteDirectory DIR_NEW_ITEM_TASKS
        mdMMVariables.deleteDirectory DIR_MOD_ITEM_TASKS
    End If
    
    If frmMMAdvancedSettings.syncNoteMode = 1 Then
        
        For i = 1 To UBound(mdVariables.notesFolders)
            If Dir(mdVariables.notesFolders(i).EntryID, vbDirectory) <> "" Then
                ChDir mdVariables.notesFolders(i).EntryID
                Kill "*.*"
                ChDir ".."
                RmDir mdVariables.notesFolders(i).EntryID 'delete the relative folder if exsists
            End If
    
        Next i
        mdMMVariables.deleteDirectory DIR_ALL_ITEM_NOTES
        mdMMVariables.deleteDirectory DIR_NEW_ITEM_NOTES
        mdMMVariables.deleteDirectory DIR_MOD_ITEM_NOTES
    End If
        
checkSlowSync_Exit:
    printDebugMessage "Exit checkForcedSlowSync method"
    Exit Sub

checkSlowSync_Err:

    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.number)
    Select Case actionToDo
    Case 0
        GoTo checkSlowSync_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select
    
    
End Sub
Public Function loadConfig()
    
    frmMMSetting.load
    
    Dim ret As Integer
    ret = 0
    If frmMMSetting.usernameText.text = "" Or frmMMSetting.passwordText.text = "" Then
        ret = MsgBox("Username and/or password are not set. Would you set it now?", vbOKCancel)
    End If
    
    loadConfig = ret
    
End Function


Public Sub synchronize()

'initialize default max date
mdActions.populateDefaultDate
createSyncManager
printDebugMessage "Enter synchronize method"
mdWinVersion.GetOSVersion
'variable that indicate the error type. If the error is critical (as "error connecting to the server") the sync stops
isBlocking = False

Dim ret As Integer
ret = loadConfig

'1 ok, 2 cancel
If ret = 1 Then
   frmMMSetting.Show 1
    Exit Sub
ElseIf ret = 2 Then
    Exit Sub
End If

Dim path As String
path = mdMMVariables.AppPath()
'ChDir (path)
ChDir (mdMMVariables.AppPath())

printDebugMessage "Current app dir: " + CurDir

Dim outlookArleadyRunning As Boolean
outlookArleadyRunning = False

'to open log file in dll
'openLog (path)
openLog (mdMMVariables.AppPath())

outlookArleadyRunning = IsOutlookProcessRunning
keyValue = getAddinValue

If outlookArleadyRunning = True Or keyValue = 2 Then
    'ok nothing to do
Else
    'check if the LoadBehavior not exists (0 is returned) or its value is set to 2 (add-in not loaded)
    'then it's possible to continue
    'if checked to 3 switch to 2 and continue
    'at the end resume the LoadBehavior to 3
    'LoadBehaviour is the key inserted by OutlookAddin to create a button in MS Outlook
    'If the Addin is arleady loaded is not possible create a reference to outlook from here
   
   If keyValue = 3 Then
    setAddinValue (2)
   End If
   
End If


StatusBar1.SimpleText = mdMMVariables.WAITLABEL_CAPTION_W
logoSync.Picture = LoadPicture(App.path & "\" & DIR_IMAGES & "\" & mdMMVariables.ARROWS_BMP)
logoSync.Enabled = False
exitButton.Caption = mdMMVariables.EXIT_BUTTON_WAIT
exitButton.Enabled = False
Wait 1

If mdMMVariables.isOutlookInitialized = False Then
   loadOutlook
   mdMMVariables.isOutlookInitialized = True
End If

checkForcedSlowSync

loadFoldersProperties

If keyValue = 3 Then
  setAddinValue (3)
End If

'try daylight set 0...
mdMMVariables.dayLight = 0 'getDayLight

'modified MM to create a string to share with dll

Dim returnXml As String
Dim insertXml As String

Dim folderType As String
Dim syncModeContacts As String
Dim syncModeCalendar As String
Dim syncModeTask As String
Dim syncModeNote As String
Dim returnedErrorFromServer As Boolean
returnedErrorFromServer = False

Dim result As Integer
Dim countInsertedItems As Integer

'initialize droppedItems variable.
'it will contains the number of the items dropped because there are in wrong format.
' used for the item that should be added
mdMMVariables.droppedItems = 0


'
' createSyncManager that needs to start sync
'


'****************SYNC CONTACTS

folderType = "" & olFolderContacts
syncModeContacts = Space(16)
result = getSourceSync(mdMMVariables.SYNC_CONTACTS, PROPERTY_SOURCE_SYNC, syncModeContacts, 16)
If Trim(syncModeContacts) <> mdMMVariables.NONE Then
    
    printLog "**********  CONTACTS SYNC  ************", INFO_LEVEL
    
    ChangeStatusBar WAIT_SYNCING_CON
    
    Dim retAllContacts As String
    Dim retNewContacts As String
    Dim retModContacts As String
    Dim retDelContacts As String
    Dim retCon As Integer
    Dim isSlowCon As String
    isSlowCon = "False"
    
    retAllContacts = ""
    retNewContacts = ""
    retDelContacts = ""
    retModContacts = ""
    mdSyncAgent.prepareSyncFiles mdVariables.contactsFolders, mdVariables.FOLDER_TYPE_CON
    isSlowCon = mdMMVariables.isChanged(mdVariables.contactsFolders)
    
    returnXml = startSynchronization(isSlowCon, folderType, path)
    If InStr(returnXml, "FAST") <> 0 Or InStr(returnXml, "SLOW") <> 0 Then ' there is an error....

        'MM to complete contact item
        If InStr(returnXml, "SLOW") <> 0 Then
            isSlowCon = "True"
            logToDebug "All contact"
            
            retAllContacts = mdMMClient2Server.getStringAllItemsInFolderContactsOnFileSystem(mdVariables.contactsFolders, mdVariables.FOLDER_TYPE_CON)
            ChangeStatusBar WAIT_SENDING_DATA
            printDebugMessage "1"
   
        Else
            isSlowCon = "False"
            logToDebug "New contact"
            retNewContacts = mdMMClient2Server.getStringNewItemsInFolderContactsOnFileSystem(mdVariables.FOLDER_TYPE_CON, _
                            mdVariables.nameSpace.GetDefaultFolder(olFolderContacts))
            
            logToDebug "Mod contact"
            retModContacts = mdMMClient2Server.getStringModItemsInFolderContactsOnFileSystem(mdVariables.FOLDER_TYPE_CON, _
                              mdVariables.nameSpace.GetDefaultFolder(olFolderContacts))
            logToDebug "Del contact"
            retDelContacts = mdMMClient2Server.getStringDelItemsInFolderContacts(mdVariables.FOLDER_TYPE_CON, _
                               mdVariables.nameSpace.GetDefaultFolder(olFolderContacts))
                               
            ChangeStatusBar WAIT_SENDING_DATA
        End If
        returnXml = synchronization(isSlowCon, retAllContacts, retNewContacts, retModContacts, retDelContacts, folderType, path)
        mdVariables.logToDebug returnXml
        returnXml = readUnicodeFile(path)
        mdVariables.logToDebug returnXml
        
    End If
    
    If InStr(Left(returnXml, 10), "Error") = 0 Then 'Error is not found! all is right
        countInsertedItems = 0
        insertXml = mdMMServer2Client.updateItemContacts(returnXml, mdVariables.FOLDER_TYPE_CON, countInsertedItems, _
                                      mdVariables.nameSpace.GetDefaultFolder(olFolderContacts))
        mdMMServer2Client.deleteItem returnXml, mdVariables.nameSpace.GetDefaultFolder(olFolderContacts)
        insertXml = insertXml + mdMMServer2Client.addItemContacts(returnXml, mdVariables.FOLDER_TYPE_CON, countInsertedItems, _
                                                  mdVariables.nameSpace.GetDefaultFolder(olFolderContacts))
        insertXml = "<mapping>" + insertXml + "</mapping>"
        logToDebug insertXml
        
        ChangeStatusBar WAIT_ENDING_SYNC
        retCon = endSynchronization(insertXml, folderType)
        
        If retCon <> 0 Then
            
            StatusBar1.SimpleText = mdMMVariables.WAITLABEL_CAPTION_ERR_ENDING_SYNC
        End If
        'ChDir (path)
        ChDir (mdMMVariables.AppPath())
        endOfFolderSyncContacts mdVariables.contactsFolders, mdVariables.FOLDER_TYPE_CON, True

    Else
        logToDebug insertXml
        StatusBar1.SimpleText = returnErrorLabel(returnXml)
        'ChDir (path)
        ChDir (mdMMVariables.AppPath())
        
        endOfFolderSyncContacts mdVariables.contactsFolders, mdVariables.FOLDER_TYPE_CON, False
        returnedErrorFromServer = True
        
    End If
    
    'modification for contact on filesystem (2.3)
   'ChDir (path)
    ChDir (mdMMVariables.AppPath())
    mdMMVariables.deleteDirectory DIR_ALL_ITEM_CONTACTS
    mdMMVariables.deleteDirectory DIR_MOD_ITEM_CONTACTS
    mdMMVariables.deleteDirectory DIR_NEW_ITEM_CONTACTS
    If mdFileSystem.doesFileExist(SERVER_ITEMS) Then
        Kill SERVER_ITEMS
    End If
                    
    retAllContacts = ""
    retNewContacts = ""
    retDelContacts = ""
    retModContacts = ""
    insertXml = ""
    returnXml = ""
    consolidatePreferences mdVariables.contactsFolders
    
'********** end sync contacts
End If

'****************** SYNC CALENDAR

folderType = "" & olFolderCalendar
syncModeCalendar = Space(16)
result = getSourceSync(mdMMVariables.SYNC_APPOINTMENTS, PROPERTY_SOURCE_SYNC, syncModeCalendar, 16)

insertXml = ""

If Trim(syncModeCalendar) <> mdMMVariables.NONE And InStr(Left(returnXml, 10), "Error") = 0 And isBlocking = False Then
    printLog "**********  CALENDAR SYNC  ************", INFO_LEVEL
    
    ChangeStatusBar WAIT_SYNCING_CAL
    
    Dim retAllCalendar As String
    Dim retNewCalendar As String
    Dim retModCalendar As String
    Dim retDelCalendar As String
    Dim retCal As Integer
    Dim isSlowCal As String
    isSlowCal = "False"
    
    'prepare the files with the related items
    mdSyncAgent.prepareSyncFiles mdVariables.calendarFolders, mdVariables.FOLDER_TYPE_CAL
    isSlowCal = mdMMVariables.isChanged(mdVariables.calendarFolders)
    returnXml = startSynchronization(isSlowCal, folderType, path)
    
    If InStr(returnXml, "FAST") <> 0 Or InStr(returnXml, "SLOW") <> 0 Then ' there is an error....
                
        If InStr(returnXml, "SLOW") <> 0 Then
            isSlowCal = "True"
            logToDebug "All calendar"
            retAllCalendar = mdMMClient2Server.getStringAllItemsInFolderOnFileSystem(mdVariables.nameSpace.GetDefaultFolder(olFolderCalendar), mdVariables.FOLDER_TYPE_CAL)
            ChangeStatusBar WAIT_SENDING_DATA
        Else
            isSlowCal = "False"
            logToDebug "New calendar"
            retNewCalendar = mdMMClient2Server.getStringNewItemsInFolderOnFileSystem(mdVariables.FOLDER_TYPE_CAL, mdVariables.nameSpace.GetDefaultFolder(olFolderCalendar))
            logToDebug "Mod calendar"
            retModCalendar = mdMMClient2Server.getStringModItemsInFolderOnFileSystem(mdVariables.FOLDER_TYPE_CAL, mdVariables.nameSpace.GetDefaultFolder(olFolderCalendar))
            logToDebug "Del calendar"
            retDelCalendar = mdMMClient2Server.getStringDelItemsInFolder(mdVariables.FOLDER_TYPE_CAL, mdVariables.nameSpace.GetDefaultFolder(olFolderCalendar))
            ChangeStatusBar WAIT_SENDING_DATA
        End If
        
        returnXml = synchronization(isSlowCal, retAllCalendar, retNewCalendar, retModCalendar, retDelCalendar, folderType, path)
        mdVariables.logToDebug returnXml
        returnXml = readUnicodeFile(path)
        mdVariables.logToDebug returnXml
    
    End If
    
    If InStr(Left(returnXml, 10), "Error") = 0 Then 'Error is not found! all is right
    
        countInsertedItems = 0
        insertXml = mdMMServer2Client.updateItem(returnXml, mdVariables.FOLDER_TYPE_CAL, countInsertedItems, mdVariables.nameSpace.GetDefaultFolder(olFolderCalendar))
        mdMMServer2Client.deleteItem returnXml, mdVariables.nameSpace.GetDefaultFolder(olFolderCalendar)
        insertXml = insertXml + mdMMServer2Client.addItem(returnXml, mdVariables.FOLDER_TYPE_CAL, countInsertedItems, mdVariables.nameSpace.GetDefaultFolder(olFolderCalendar))
        insertXml = "<mapping>" + insertXml + "</mapping>"
        
        ChangeStatusBar WAIT_ENDING_SYNC
        
        logToDebug insertXml
        retCal = endSynchronization(insertXml, folderType)
        
        If retCal <> 0 Then
            
            StatusBar1.SimpleText = mdMMVariables.WAITLABEL_CAPTION_ERR_ENDING_SYNC
        End If
                
        endOfFolderSync olFolderCalendar, mdVariables.FOLDER_TYPE_CAL, True
        
    Else
        logToDebug returnXml
        StatusBar1.SimpleText = returnErrorLabel(returnXml)
        endOfFolderSync olFolderCalendar, mdVariables.FOLDER_TYPE_CAL, False
        returnedErrorFromServer = True
        
    End If
    
     'modification on filesystem (2.3)
    mdMMVariables.deleteDirectory DIR_ALL_ITEM_CALENDARS
    mdMMVariables.deleteDirectory DIR_NEW_ITEM_CALENDARS
    mdMMVariables.deleteDirectory DIR_MOD_ITEM_CALENDARS
    If mdFileSystem.doesFileExist(SERVER_ITEMS) Then
        Kill SERVER_ITEMS
    End If
    
    retAllCalendar = ""
    retNewCalendar = ""
    retDelCalendar = ""
    retModCalendar = ""
    insertXml = ""
    returnXml = ""
    consolidatePreferences mdVariables.calendarFolders
'********* end Sync calendar
End If

'****************** SYNC TASKS *********************************************

folderType = "" & olFolderTasks
syncModeTask = Space(16)
result = getSourceSync(mdMMVariables.SYNC_TASKS, PROPERTY_SOURCE_SYNC, syncModeTask, 16)
insertXml = ""

If Trim(syncModeTask) <> mdMMVariables.NONE And InStr(Left(returnXml, 10), "Error") = 0 And isBlocking = False Then
    
    printLog "**********  TASKS SYNC  ************", INFO_LEVEL
    
    ChangeStatusBar WAIT_SYNCING_TASK
    
    Dim retAllTask As String
    Dim retNewTask As String
    Dim retModTask As String
    Dim retDelTask As String
    Dim retTas As Integer
    Dim isSlowTas As String
    isSlowTas = "False"
    
    'prepare the files with the related items
    mdSyncAgent.prepareSyncFiles mdVariables.tasksFolders, mdVariables.FOLDER_TYPE_TASK
    isSlowTas = mdMMVariables.isChanged(mdVariables.tasksFolders)
    returnXml = startSynchronization(isSlowTas, folderType, path)
    
    If InStr(returnXml, "FAST") <> 0 Or InStr(returnXml, "SLOW") <> 0 Then ' there is an error....
        If InStr(returnXml, "SLOW") <> 0 Then
            isSlowTas = "True"
            logToDebug "All Tasks"
            retAllTask = mdMMClient2Server.getStringAllItemsInFolderOnFileSystem(mdVariables.nameSpace.GetDefaultFolder(olFolderTasks), mdVariables.FOLDER_TYPE_TASK)
            ChangeStatusBar WAIT_SENDING_DATA
        Else
            isSlowTas = "False"
            logToDebug "New tasks"
            retNewTask = mdMMClient2Server.getStringNewItemsInFolderOnFileSystem(mdVariables.FOLDER_TYPE_TASK, mdVariables.nameSpace.GetDefaultFolder(olFolderTasks))
            logToDebug "Mod tasks"
            retModTask = mdMMClient2Server.getStringModItemsInFolderOnFileSystem(mdVariables.FOLDER_TYPE_TASK, mdVariables.nameSpace.GetDefaultFolder(olFolderTasks))
            logToDebug "Del tasks"
            retDelTask = mdMMClient2Server.getStringDelItemsInFolder(mdVariables.FOLDER_TYPE_TASK, mdVariables.nameSpace.GetDefaultFolder(olFolderTasks))
            ChangeStatusBar WAIT_SENDING_DATA
        End If
        
        returnXml = synchronization(isSlowTas, retAllTask, retNewTask, retModTask, retDelTask, folderType, path)
        mdVariables.logToDebug returnXml
        returnXml = readUnicodeFile(path)
        mdVariables.logToDebug returnXml
    
    End If
    
    If InStr(Left(returnXml, 10), "Error") = 0 Then 'Error is not found! all is right
    
        countInsertedItems = 0
        insertXml = mdMMServer2Client.updateItem(returnXml, mdVariables.FOLDER_TYPE_TASK, countInsertedItems, mdVariables.nameSpace.GetDefaultFolder(olFolderTasks))
        mdMMServer2Client.deleteItem returnXml, mdVariables.nameSpace.GetDefaultFolder(olFolderTasks)
        insertXml = insertXml + mdMMServer2Client.addItem(returnXml, mdVariables.FOLDER_TYPE_TASK, countInsertedItems, mdVariables.nameSpace.GetDefaultFolder(olFolderTasks))
        insertXml = "<mapping>" + insertXml + "</mapping>"
        
        ChangeStatusBar WAIT_ENDING_SYNC
        logToDebug insertXml
        retTas = endSynchronization(insertXml, folderType)
        
        If retTas <> 0 Then
            
            StatusBar1.SimpleText = mdMMVariables.WAITLABEL_CAPTION_ERR_ENDING_SYNC
        End If
                
        endOfFolderSync olFolderTasks, mdVariables.FOLDER_TYPE_TASK, True
        
    Else
        logToDebug returnXml
        StatusBar1.SimpleText = returnErrorLabel(returnXml)
        endOfFolderSync olFolderTasks, mdVariables.FOLDER_TYPE_TASK, False
        returnedErrorFromServer = True
        
    End If
        
    'modification on filesystem (2.3)
    mdMMVariables.deleteDirectory DIR_ALL_ITEM_TASKS
    mdMMVariables.deleteDirectory DIR_NEW_ITEM_TASKS
    mdMMVariables.deleteDirectory DIR_MOD_ITEM_TASKS
    If mdFileSystem.doesFileExist(SERVER_ITEMS) Then
        Kill SERVER_ITEMS
    End If
    
    retAllTask = ""
    retNewTask = ""
    retDelTask = ""
    retModTask = ""
    insertXml = ""
    returnXml = ""
    consolidatePreferences mdVariables.tasksFolders
'********* end Sync tasks **********************************************************

End If

'****************** SYNC NOTES *********************************************

folderType = "" & olFolderNotes
syncModeNote = Space(16)
result = getSourceSync(mdMMVariables.SYNC_NOTES, PROPERTY_SOURCE_SYNC, syncModeNote, 16)

insertXml = ""

If Trim(syncModeNote) <> mdMMVariables.NONE And InStr(Left(returnXml, 10), "Error") = 0 And isBlocking = False Then
    printLog "**********  NOTES SYNC  ************", INFO_LEVEL
    
    ChangeStatusBar WAIT_SYNCING_NOTE
    
    Dim retAllNote As String
    Dim retNewNote As String
    Dim retModNote As String
    Dim retDelNote As String
    Dim retNot As Integer
    Dim isSlowNot As String
    isSlowNot = "False"
    
    mdSyncAgent.prepareSyncFiles mdVariables.notesFolders, mdVariables.FOLDER_TYPE_NOTE
    isSlowNot = mdMMVariables.isChanged(mdVariables.notesFolders)
    returnXml = startSynchronization(isSlowNot, folderType, path)
    
    If InStr(returnXml, "FAST") <> 0 Or InStr(returnXml, "SLOW") <> 0 Then ' there is an error....
            
         If InStr(returnXml, "SLOW") <> 0 Then
            isSlowNot = "True"
            logToDebug "All Notes"
            retAllNote = mdMMClient2Server.getStringAllItemsInFolderOnFileSystem(mdVariables.nameSpace.GetDefaultFolder(olFolderNotes), mdVariables.FOLDER_TYPE_NOTE)
            ChangeStatusBar WAIT_SENDING_DATA
        Else
            isSlowNot = "False"
            logToDebug "New Notes"
            retNewNote = mdMMClient2Server.getStringNewItemsInFolderOnFileSystem(mdVariables.FOLDER_TYPE_NOTE, mdVariables.nameSpace.GetDefaultFolder(olFolderNotes))
            logToDebug "Mod Notes"
            retModNote = mdMMClient2Server.getStringModItemsInFolderOnFileSystem(mdVariables.FOLDER_TYPE_NOTE, mdVariables.nameSpace.GetDefaultFolder(olFolderNotes))
            logToDebug "Del Notes"
            retDelNote = mdMMClient2Server.getStringDelItemsInFolder(mdVariables.FOLDER_TYPE_NOTE, mdVariables.nameSpace.GetDefaultFolder(olFolderNotes))
            ChangeStatusBar WAIT_SENDING_DATA
        End If
        
        returnXml = synchronization(isSlowNot, retAllNote, retNewNote, retModNote, retDelNote, folderType, path)
        mdVariables.logToDebug returnXml
        returnXml = readUnicodeFile(path)
        mdVariables.logToDebug returnXml
    
    End If
    
    If InStr(Left(returnXml, 10), "Error") = 0 Then 'Error is not found! all is right
    
        countInsertedItems = 0
        insertXml = mdMMServer2Client.updateItem(returnXml, mdVariables.FOLDER_TYPE_NOTE, countInsertedItems, mdVariables.nameSpace.GetDefaultFolder(olFolderNotes))
        mdMMServer2Client.deleteItem returnXml, mdVariables.nameSpace.GetDefaultFolder(olFolderNotes)
        insertXml = insertXml + mdMMServer2Client.addItem(returnXml, mdVariables.FOLDER_TYPE_NOTE, countInsertedItems, mdVariables.nameSpace.GetDefaultFolder(olFolderNotes))
        insertXml = "<mapping>" + insertXml + "</mapping>"
        
        ChangeStatusBar WAIT_ENDING_SYNC
        
        logToDebug insertXml
        retNot = endSynchronization(insertXml, folderType)
        
        If retNot <> 0 Then
            
            StatusBar1.SimpleText = mdMMVariables.WAITLABEL_CAPTION_ERR_ENDING_SYNC
        End If
        endOfFolderSync olFolderNotes, mdVariables.FOLDER_TYPE_NOTE, True
        
    Else
        logToDebug returnXml
        
        StatusBar1.SimpleText = returnErrorLabel(returnXml)
        endOfFolderSync olFolderNotes, mdVariables.FOLDER_TYPE_NOTE, False
        returnedErrorFromServer = True
        
    End If
    
    'modification on filesystem (2.3)
    mdMMVariables.deleteDirectory DIR_ALL_ITEM_NOTES
    mdMMVariables.deleteDirectory DIR_NEW_ITEM_NOTES
    mdMMVariables.deleteDirectory DIR_MOD_ITEM_NOTES
    If mdFileSystem.doesFileExist(SERVER_ITEMS) Then
        Kill SERVER_ITEMS
    End If
    
    retAllNote = ""
    retNewNote = ""
    retDelNote = ""
    retModNote = ""
    insertXml = ""
    returnXml = ""
    
    consolidatePreferences mdVariables.notesFolders
'********* end Sync notes **********************************************************
End If

'
' deleteSyncManager at the end of the sync
'
deleteSyncManager

If Trim(syncModeContacts) = mdMMVariables.NONE And Trim(syncModeCalendar) = mdMMVariables.NONE _
                            And Trim(syncModeTask) = mdMMVariables.NONE And Trim(syncModeNote) = mdMMVariables.NONE Then
    
    StatusBar1.SimpleText = mdMMVariables.WAITLABEL_NO_SOURCE_TO_SYNC
    printLog mdMMVariables.WAITLABEL_NO_SOURCE_TO_SYNC, INFO_LEVEL
    printLog "Sync ended", INFO_LEVEL
    

ElseIf mdMMVariables.droppedItems > 0 Then
    StatusBar1.SimpleText = mdMMVariables.WAITLABEL_CAPTION_DROPPED
ElseIf isBlocking = True Then
'leave the error

ElseIf returnedErrorFromServer = True Then
    StatusBar1.SimpleText = mdMMVariables.WAITLABEL_CAPTION_COMPLETED_WITH_ERROR
Else

    StatusBar1.SimpleText = mdMMVariables.WAITLABEL_CAPTION_END
End If

logoSync.Picture = LoadPicture(App.path & "\" & DIR_IMAGES & "\" & mdMMVariables.ARROWS_BMP)
logoSync.Enabled = True
exitButton.Caption = mdMMVariables.EXIT_BUTTON
exitButton.Enabled = True

frmMMAdvancedSettings.discardValues

'to close log file in dll
closeLog

Close

End Sub
Function returnErrorLabel(ByVal xml As String)

    Dim initCode As Long
    Dim endCode As Long
    Dim errorCode As String
    Dim originalErrorMessage As String
    
    errorCode = ""
    originalErrorMessage = ""
    
    initCode = InStr(xml, "error code: ")
    endCode = InStr(xml, "error message:")
    If initCode <> 0 Then
        initCode = initCode + Len("error code: ")
        If endCode <> 0 Then
            errorCode = Mid(xml, initCode, endCode - initCode - 1)
            
        End If
        
    End If
    
    'to retrieve the original native api message
    initCode = InStr(xml, "error message:")
    If initCode <> 0 Then
        initCode = initCode + Len("error message: ")
        originalErrorMessage = Mid(xml, initCode)
    End If
    
    Select Case errorCode
        Case ERR_READING_CONTENT
            printLog mdMMVariables.MSG_ERR_READING_CONTENT, INFO_LEVEL
            returnErrorLabel = mdMMVariables.MSG_ERR_READING_CONTENT
            isBlocking = True
         Case ERR_HTTP
            printLog mdMMVariables.MSG_ERR_ERR_HTTP, INFO_LEVEL
            returnErrorLabel = mdMMVariables.MSG_ERR_ERR_HTTP
            isBlocking = True
        Case ERR_PROTOCOL_ERROR
            printLog mdMMVariables.MSG_ERR_PROTOCOL_ERROR, INFO_LEVEL
            returnErrorLabel = mdMMVariables.MSG_ERR_PROTOCOL_ERROR
            isBlocking = True
        Case ERR_AUTH_REQUIRED
            printLog mdMMVariables.MSG_ERR_AUTH_REQUIRED, INFO_LEVEL
            returnErrorLabel = mdMMVariables.MSG_ERR_AUTH_REQUIRED
            isBlocking = True
        Case ERR_NOT_FOUND
            printLog originalErrorMessage + " Please check Synchronization Settings -> Remote Settings name", INFO_LEVEL
            returnErrorLabel = originalErrorMessage
            isBlocking = False
        Case ERR_CONNECT
            printLog mdMMVariables.MSG_ERR_CONNECT, INFO_LEVEL
            returnErrorLabel = mdMMVariables.MSG_ERR_CONNECT
            isBlocking = True
        Case ERR_RESP_URI_DIFFERS_FROM_URL
            printLog originalErrorMessage, INFO_LEVEL
            returnErrorLabel = originalErrorMessage
            isBlocking = True
        Case ERR_GENERIC_FAULT
            printLog originalErrorMessage, INFO_LEVEL
            returnErrorLabel = mdMMVariables.MSG_ERR_GENERIC
            isBlocking = True
        Case Else
            printLog mdMMVariables.MSG_ERR_GENERIC, INFO_LEVEL
            returnErrorLabel = mdMMVariables.MSG_ERR_GENERIC  'xml
            isBlocking = True
    End Select
    

End Function

Private Sub logControl_Click()
    Dim path As String
    path = mdMMVariables.AppPath()
    path = path + "sync.txt"
    If mdFileSystem.doesFileExist(path) Then
        Shell "Notepad " & path, vbNormalFocus
    Else
        Shell "Notepad ", vbNormalFocus
    End If
End Sub

Private Sub syncControl_Click(Index As Integer)
    synchronize
End Sub

Private Sub syncSchedulerSettings_Click(Index As Integer)
    frmScheduler.Show 1
End Sub


Private Sub syncSettingsControl_Click(Index As Integer)
    frmMMSetting.Show 1
End Sub

Private Sub syncSourcesControl_Click(Index As Integer)
    frmMMSettingSources.Show 1
    
End Sub


Private Sub Form_Unload(Cancel As Integer)
mdUnload.closeProgram
End Sub



